-----------------------------------------------------------------------------
-- |
-- Module      :  System.UTF8IO
-- Copyright   :  (c) Péter Diviánszky 2008
-- License     :  BSD3-style (see LICENSE)
-- 
-- Maintainer:    divip@aszt.inf.elte.hu
-- Stability   :  alpha
-- Portability :  portable
--
-- This module defines the same entities as "System.IO" but uses UTF8 encoding.
--
-- Usage:
--
-- > import System.UTF8IO
--
-- And you probably want to declare:
--
-- > import qualified Prelude
-- > import UTF8Prelude
--
-- This module is based on "System.IO.UTF8".

module System.UTF8IO
    ( module System.IO
    , module System.IO.UTF8
    ) where

import System.IO.UTF8 hiding
    ( print
    , putStr
    , putStrLn
    , getLine
    , readLn
    , readFile
    , writeFile
    , appendFile
    , getContents
    )

import System.IO hiding 
    ( print
    , putStr
    , putStrLn
    , getLine
    , readLn
    , readFile
    , writeFile
    , appendFile
    , getContents
    , hGetLine
    , hGetContents
    , hPutStr
    , hPutStrLn
    )




